package ch.kousz.adrian.encfs;

import ch.kousz.adrian.util.LineIterable;
import ch.kousz.adrian.util.StringGenerator;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStreamReader;
import java.util.Iterator;
import org.mrpdaemon.sec.encfs.EncFSBinaryConfig;
import org.mrpdaemon.sec.encfs.EncFSConfig;
import org.mrpdaemon.sec.encfs.EncFSConfigParser;
import org.mrpdaemon.sec.encfs.EncFSUtil;

public class EncFSBrute
{
	@SuppressWarnings("UseOfSystemOutOrSystemErr")
	public static void main(String[] args)
	throws Exception
	{
		if (args.length < 3) {
			System.out.println("USAGE: EncFSBrute <encfs xml path> <charset> <min length> [<start>]");
			System.out.println("or:    EncFSBrute <encfs xml path> \"wordlist\" <wordlist path> [<start>]");
			return;
		}

		String filename = args[0];
		String charset = args[1];
		String param = args[2];
		String start = null;
		if (args.length == 4) start = args[3];

		Iterator<String> passwordIterator;

		if ("wordlist".equals(charset)) {
			BufferedReader rdr = new BufferedReader(new InputStreamReader(new FileInputStream(param), "UTF-8"));
			passwordIterator = new LineIterable(rdr).iterator();
		} else {
			int minLength = Integer.parseInt(param);
			passwordIterator = new StringGenerator(charset, minLength).iterator();
		}

		EncFSConfig config = EncFSConfigParser.parseFile(new File(filename));
		EncFSBinaryConfig binaryConfig = EncFSBinaryConfig.from(config);

		if (start != null) {
			System.err.printf("Skipping to \"%s\"...\n", start);
			String skip = "";
			while (! skip.equals(start)) skip = passwordIterator.next();
		}

		while (true) {
			String pw = passwordIterator.next();
			System.err.println(pw);
			boolean ok = EncFSUtil.checkPassword(binaryConfig, pw);
			if (ok) {
				System.out.println(pw);
				break;
			}
		}
	}
}
